<?php
	header("Content-Type: text/plain"); 

	//simple variables
	$variable = "string";				
	$variable2 = 34;
	$variable3 = $variable2 * 45;
	
	//arrays
	$array = array("Name" => "Hans", "Alter" => 24);		
	$array2 = array(0 => "foo", 1 => "bar");
	$array3 = array("München", "Hannover", "Berlin"); 
	echo $array["Name"]."\r\n"; 	//prints "Hans"
	echo $array2[0]."\r\n";			//prints "foo"
	echo $array3[2]."\r\n"; 		//prints "Berlin"
	echo "\r\n";					//line break
	
	//if-else statements
	if($variable == 34){		//"true" will be printed
		echo "true\r\n";	
	}else{
		echo "false\r\n";	
	}
	
	//loops
	echo "\r\n";
	for($i = 0; $i < count($array3); ++$i){		//prints "München\r\nHannover\r\nBerlin"
		echo $array3[$i]."\r\n";	
	}
	echo "\r\n";
	
	foreach($array3 as $element){
		echo $element."\r\n";
	}
	echo "\r\n";
	
	$a = 0;
	while($a < 10){
		echo $a." ";
		++$a;
	}
	echo "\r\n\r\n";
	
	//functions
	function add($a, $b){
		return $a + $b;	
	}
	echo "2 + 6 = ".add(2, 6);
	echo "\r\n\r\n";
		
	//classes
	//define a class
	class Vec2D{  
		//private member variables
    	private $_x;
		private $_y;  
		
		//constructor
		//$this is a reference on the instance itself
		public function Vec2D($x, $y){  
			$this->_x = $x;
			$this->_y = $y;
		}  
	  
	  	//some getters and setters for the private member variables
		public function getX(){
			return $this->_x;	
		}
	  
	  	public function getY(){
			return $this->_y;	
		}
		
		public function setX($x){
			$this->_x = $x;	
		}
		
		public function setY($y){
			$this->_y = $y;	
		}		
	  
	  	//a member function (calculates the length)
		public function length(){  
			return sqrt($this->_x * $this->_x + $this->_y * $this->_y);  
		} 
		
		//a static function - static member functions can be called without having an instance of the object
		//in this case the dot product of two 2D vectors
		public static function dotP($a,$b){
			return $a->getX() * $b->getX() + $a->getY() * $b->getY();	
		}
	}
	
	//create two new vector objects
	$vec1 = new Vec2D(2, 5);
	$vec2 = new Vec2D(6,-3);
	//print the x component of vector 1 (calling a member function)
	echo $vec1->getX()."\r\n";
	//print the length of vector 1 (calling a member function)
	echo $vec1->length()."\r\n";
	//set the y value of vec1 to 7 (calling a member function)
	$vec1->setY(7);
	//again, print the length
	echo $vec1->length()."\r\n";
	//call of a static function (whithout instance)
	echo Vec2D::dotP($vec1, $vec2);
	
	//inheritance: classes can be extended like this
	class Vec2DExtended extends Vec2D{
		private $newStuff;
	}
?>